if($Pref::Server::CrouchJump::HeightInPlates $= "")
	$Pref::Server::CrouchJump::HeightInPlates = 7; //default - 2 bricks 1 plate high.
//1 brick is 3 plates high and a player can normally jump around 5 bricks 2 plates high, so add this pref to that to determine full jump height
//minimum is 0 which disables it (playertypes can bypass this using the below value) - maximum is 7, anything higher could result in players very easily going through ceilings

//crouchJummp_heightInPlates = 7;
//add this to your playertype to set its specific crouch jump height. if it is 0 (or unset) then it will use the server pref above.

if($Pref::Server::CrouchJump::BypassHeightMax $= "")
	$Pref::Server::CrouchJump::BypassHeightMax = false; //default
//set to true to allow setting the height in plates pref to over 7.
//WARNING: this is unsupported, players will very likely get stuck in bricks or go all the way through bricks. though it could be useful for messing aroumd.

if($Pref::Server::CrouchJump::TickLength $= "")
	$Pref::Server::CrouchJump::TickLength = 100; //default
//lower it to more accurately check if the player has touched the ground, though it may impact performance.

//RTB Prefs
if($RTB::Hooks::ServerControl)
{
	RTB_registerPref("Crouch jump height (in plates)",						"Crouch Jump",	"$Pref::Server::CrouchJump::HeightInPlates",	"int 0 7",		"Server_CrouchJump",	7,		false,	false,	false);
	//RTB_registerPref("Bypass jump height pref limitation",					"Crouch Jump",	"$Pref::Server::CrouchJump::BypassHeightMax",	"bool",			"Server_CrouchJump",	false,	false,	false,	false);
	RTB_registerPref("Ground check accuracy (lower = better but laggier)",	"Crouch Jump",	"$Pref::Server::CrouchJump::TickLength",		"int 10 200",	"Server_CrouchJump",	100,	false,	false,	false);
}

package crouchJumpPackage
{
	function armor::onTrigger(%this, %obj, %trigger, %val)
	{
		parent::onTrigger(%this, %obj, %trigger, %val);
		
		%height = mfloor(%obj.getDatablock().crouchJummp_heightInPlates);
		if(%height <= 0) //check for playertypes that bypasses the pref
		{
			%height = mfloor($Pref::Server::CrouchJump::HeightInPlates);
			
			if(!$Pref::Server::CrouchJump::BypassHeightMax)
			{
				if(%height > 7) //maximum check
					$Pref::Server::CrouchJump::HeightInPlates = 7;
				else if(%height < 0) //minimum check
				{
					$Pref::Server::CrouchJump::HeightInPlates = 0;
					return;
				}
			}
			
			if(%height == 0) //disabled check
			{
				$Pref::Server::CrouchJump::HeightInPlates = 0; //we do this just in case they set it to something that is not a number.
				return;
			}
			else if(%height > 2000000000) //due to int limitation
				$Pref::Server::CrouchJump::HeightInPlates = 2000000000;
			else if(%height < -2000000000) //due to int limitation
				$Pref::Server::CrouchJump::HeightInPlates = -2000000000;
			
			%height = $Pref::Server::CrouchJump::HeightInPlates; //to get the changes if any occured
		}
		
		if(%trigger == 3 &&
		   %obj.scale $= "1 1 1" &&
		   %val == 1) //check if the trigger was a crouch - only works with default scale - only happens at start of crouch
		{
			if(%obj.crouchJump_isCrouchingInAir == false)
			{
				if(%obj.crouchJump_checkInAir()) //if they are in the air then they are crouching in the air.
				{
					%obj.crouchJump_isCrouchingInAir = true;
					%obj.setTransform(vectorAdd(%obj.getPosition(), "0 0" SPC ((%height * 0.2) - 0.05)));
					schedule(100, 0, crouchJump_tick, %obj, 0);
				}
			}
		}
		
		return;
	}
};
activatePackage(crouchJumpPackage);

function Player::crouchJump_checkInAir(%this)
{
	if(!isObject(%this))
		return;
	
	%pos = %this.getPosition();
	%mask = $TypeMasks::FxBrickObjectType | $TypeMasks::StaticObjectType;

	//ground plane check
	if(getWord(%pos, 2) < 0.1 && getWord(%pos, 2) > -0.1) //adding a > check just in case someone decided to delete the floor - it'll be barely noticable now
		return false;
	
	initContainerBoxSearch(vectorAdd(%pos, "0 0 0.8"), "1.25 1.25 3", %mask); //also checks if there's anything above the player so we have better luck at not allowing the player to duck through ceilings - may disallow players to crouch jump if their head is right at the ceiling
	
	%obj = containerSearchNext();
	if(isObject(%obj) && %obj != SunLight.getId() && %obj != %this.getId())
	{
		if(%obj.getClassName() $= "fxDTSBrick" && !%obj.isColliding())
			return true;
		
		return false;
	}
	
	return true;
}

function crouchJump_tick(%player, %num)
{
	if(!isObject(%player))
		return;
	
	if(%num < 500 && %player.crouchJump_isCrouchingInAir == true) //its just going to stop checking after a bit - dont think i should keep this going forever
	{
		if(%player.crouchJump_checkInAir())
		{
			%time = mfloor($Pref::Server::CrouchJump::TickLength);
			
			if(%time > 200)
				$Pref::Server::CrouchJump::TickLength = 200;
			else if(%time < 10)
				$Pref::Server::CrouchJump::TickLength = 10;
			
			%time = $Pref::Server::CrouchJump::TickLength;
			
			schedule(%time, 0, crouchJump_tick, %player, %num++);
			return;
		}
		else
			%player.crouchJump_isCrouchingInAir = false;
	}
	else
		%player.crouchJump_isCrouchingInAir = false;
}